// e682.c
/*
 * This outputs the data from the outpixels structure and spits them out on
 * ip address for the E682 board to process and command smart strings
 * to operate.
 *
 * IP addresses are set in EthSetDesc, and have one IP address per universe.
 * While this limits code to 256 universes, that's reasonable for this application
 * and we are limited to universes 10-100 anyway.
 *
 * ETHERNET
 */

// 001 -- modded EthSetDesc to permit multiple groups of lights into the same universe

#include "predef.h"
#include <constants.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>
#include <basictypes.h>

#include <smarttrap.h>
#include <taskmon.h>
#include <sim.h>
#include <pins.h>
#include <NetworkDebug.h>

#include <startnet.h>
#include <ethernet.h>
//#include <autoupdate.h>
#include <NetworkDebug.h>
#include <udp.h>

//#include <bsp.h>                // 5270 board support package interface
#include <smarttrap.h>          // NetBurner Smart Trap utility
#include <utils.h>              // Include for LED writes on carrier board
#include <constants.h>          // Include for constands like MAIN_PRIO
#include <system.h>             // Include for system functions
#include <string.h>
#include "shows.h"
#include "xmas2011.h"
#include "E682.h"
//#include <ucos.h>
#include <nbrtos.h>
#include <init.h>
//#include <cfinter.h>  // INTERRUPTS
#include <pins.h>
//#include <a2d.h>
//extern IPADDR 	E682ipaddr; // address to send to
// universecross cross references a universe to its list
INT16 universecross[NUMUNIV];
unsigned char sequenceout[NUMUNIV]; // one per universe to speed up code
static INT16 universeindex; // count of how many universes have been seen
/*Universelist
 *
 * IPADDR ipaddr
 * uint16 local channel start
 * uint16 num channels
 * unsigned char universe
 */
struct universelist EthDesc[NUMUNIV];

unsigned char EthInit[]={ //128 byte initialized structure
0x00, 0x10, 0x00, 0x00, 0x41, 0x53, 0x43, 0x2d, 0x45, 0x31, 0x2e, 0x31, 0x37, 0x00, 0x00, 0x00,
0x70, 0xae, 0x00, 0x00, 0x00, 0x04, 0x19, 0xc9, 0xdd, 0xb7, 0x75, 0x0b, 0xd9, 0x48, 0x82, 0x4f,
0xdb, 0xba, 0xf4, 0xb4, 0x9f, 0x24, 0x70, 0x98, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x64, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xa1, 0x00, 0x00, 0x00, 0x01, 0x00, 0x41, 0x00, 0x00, 0x00
};// initial data for E1.31 transmissions

char EthBuffer[1500]; // buffer space to build message in
int outportnum = 5568;
extern pixel outpixels[NUMETHLIGHTS];
extern unsigned char tempchar;
extern int universecount;
char * EthList[] = {
				"0", "0", "0", "0", "0", //0
				"0", "0", "0", "0", "0", //5
				"192.168.1.204","192.168.1.205","192.168.1.205","192.168.1.205","192.168.1.204", //10
				"192.168.1.205","0","192.168.1.204", "0", "0", //15
				"0", "192.168.1.203", "192.168.1.203", "192.168.1.203", "0",//20
				"0", "0", "0", "0", "0",//25
				"0", "0", "0", "0", "0",//30
				"0", "0", "0", "0", "0",//35
				"0", "0", "0", "0", "0",//40
				"0", "0", "0", "0", "0",//45
				"0", "0", "0", "0", "0",//50
				"0", "0", "0", "0", "0",//55
				"0", "0", "0", "0", "0",//60
				"0", "0", "0", "0", "0",//65
				"0", "0", "0", "0", "0",//70
				"0", "0", "0", "0", "0",//75
				"0", "0", "0", "0", "0",//80
				"0", "0", "0", "0", "0",//85
				"0", "0", "0", "0", "0",//90
				"0", "0", "0", "0", "0"//95
				"0", "0", "0", "0", "0", //-100
				"0", "0", "0", "0", "0", //5
				"0","0","0","0","0", //10
				"0","0","0", "0", "0", //15
				"0", "0", "0", "0", "0",//20
				"0", "0", "0", "0", "0",//25
				"0", "0", "0", "0", "0",//30
				"0", "0", "0", "0", "0",//35
				"0", "0", "0", "0", "0",//40
				"0", "0", "0", "0", "0",//45
				"0", "0", "0", "0", "0",//50
				"0", "0", "0", "0", "0",//55
				"0", "0", "0", "0", "0",//60
				"0", "0", "0", "0", "0",//65
				"0", "0", "0", "0", "0",//70
				"0", "0", "0", "0", "0",//75
				"0", "0", "0", "0", "0",//80
				"0", "0", "0", "0", "0",//85
				"0", "0", "0", "0", "0",//90
				"0", "0", "0", "0", "0"//95	-99
				"0", "0", "0", "0", "0", //-200
				"0", "0", "0", "0", "0", //5
				"0","0","0","0","0", //10
				"0","0","0", "0", "0", //15
				"0", "0", "0", "0", "0",//20
				"0", "0", "0", "0", "0",//25
				"0", "0", "0", "0", "0",//30
				"0", "0", "0", "0", "0",//35
				"0", "0", "0", "0", "0",//40
				"0", "0", "0", "0", "0",//45
				"0", "0", "0", "0", "0",//50
				"0", "0", "0", "0", "0",//55
				"0", "0", "0", "0", "0",//60
				"0", "0", "0", "0", "0",//65
				"0", "0", "0", "0", "0",//70
				"0", "0", "0", "0", "0",//75
				"0", "0", "0", "0", "0",//80
				"0", "0", "0", "0", "0",//85
				"0", "0", "0", "0", "0",//90
				"0", "0", "0", "0", "0"//95	-99
				"0", "0", "0", "0", "0", //-300
				"0", "0", "0", "0", "0", //5
				"0","0","0","0","0", //10
				"0","0","0", "0", "0", //15
				"0", "0", "0", "0", "0",//20
				"0", "0", "0", "0", "0",//25
				"0", "0", "0", "0", "0",//30
				"0", "0", "0", "0", "0",//35
				"0", "0", "0", "0", "0",//40
				"0", "0", "0", "0", "0",//45
				"0", "0", "0", "0", "0",//50
				"0", "0", "0", "0", "0",//55
				"0", "0", "0", "0", "0",//60
				"0", "0", "0", "0", "0",//65
				"0", "0", "0", "0", "0",//70
				"0", "0", "0", "0", "0",//75
				"0", "0", "0", "0", "0",//80
				"0", "0", "0", "0", "0",//85
				"0", "0", "0", "0", "0",//90
				"0", "0", "0", "0", "0"//95	-99
				"0", "0", "0", "0", "0", //-400
				"0", "0", "0", "0", "0", //5
				"0","0","0","0","0", //10
				"0","0","0", "0", "0", //15
				"0", "0", "0", "0", "0",//20
				"0", "0", "0", "0", "0",//25
				"0", "0", "0", "0", "0",//30
				"0", "0", "0", "0", "0",//35
				"0", "0", "0", "0", "0",//40
				"0", "0", "0", "0", "0",//45
				"0", "0", "0", "0", "0",//50
				"0", "0", "0", "0", "0",//55
				"0", "0", "0", "0", "0",//60
				"0", "0", "0", "0", "0",//65
				"0", "0", "0", "0", "0",//70
				"0", "0", "0", "0", "0",//75
				"0", "0", "0", "0", "0",//80
				"0", "0", "0", "0", "0",//85
				"0", "0", "0", "0", "0",//90
				"0", "0", "0", "0", "0"//95	-99
				"0", "0", "0", "0", "0", //-500
				"0", "0", "0", "0", "0", //5
				"0","0" //10
		};

/*
 * checks if we have
 */
void EthSetDesc(unsigned char univ, INT16 beginning, INT16 numchan)
{
INT16 ethTempshort;
	if (universecross[univ]==0) // not seen send to this universe before
	{
		universeindex+=1;
		universecross[univ]= universeindex; // we start at index 1
		iprintf("%d universe added ",univ);
		EthDesc[universeindex].univ = univ;
		EthDesc[universeindex].startchannel = beginning;
		EthDesc[universeindex].numchannels = numchan;
		// ASSIGN IP addresses to the universes
		if (univ<NUMUNIV)
		{
		EthDesc[universeindex].ip = AsciiToIp(EthList[univ]);
		iprintf(" to %s\n", EthList[univ]);
		}
		else
		{
			iprintf("ERR UNIVERSE > 511 !!!");
		}
	}
// 001 make it so you can have several groups in the same universe IE multiple strings of 50 ws2811 doing diff things
	else
	    {
	    ethTempshort = EthDesc[universecross[univ]].startchannel + EthDesc[universecross[univ]].numchannels;
	    if (beginning >= ethTempshort)
		{
		EthDesc[universecross[univ]].numchannels += numchan;// add this to the maximum for this universe
		iprintf("%d universe now holds %d channels\n",univ, EthDesc[universecross[univ]].numchannels);
		}
	    }
}

void ResetEthDesc()
{
	INT16 *rstptr;
	unsigned char *rstptr2;

	universeindex = 0;
	rstptr = &universecross[0];
	memset(rstptr, 0x00, 256); // wipe the cross reference clean
	rstptr2 = &sequenceout[0];
	memset(rstptr2, 0x00, 512);// set all sequences to zero
}

void SetEthSeq(int univ, unsigned char seqcount)
{
	sequenceout[univ]= seqcount;
}

unsigned char GetIncSeq(int univ )
{

	sequenceout[univ] += 1; // rollover is expected and okay
	return sequenceout[univ];
}


void OutputEth()
{
int outind, tempoutint,univ;
uint16_t tempsize;
unsigned char *buffer2;

outind = 1; // We start the indexing from 1, not 0, so index of 0 is undefined
while (EthDesc[outind].univ != 0) // repeat while there's an universe to send to
	{
	univ = EthDesc[outind].univ;

	UDPPacket pkt; // outgoing data
	buffer2 = (unsigned char *)&EthBuffer[0];
	memcpy(buffer2, EthInit, sizeof(EthInit)); // copy initial buffer
	buffer2[111] = GetIncSeq(univ); // set sequence number
	buffer2[114] = (unsigned char)univ; // set universe, 0 - 255
	buffer2[113] = (unsigned char)(univ >> 8);//set universe high byte

	tempsize = EthDesc[outind].numchannels*3;// three lights per, RGB
	tempchar = (unsigned char)(tempsize>>8);
	tempchar |= 0x70;
	buffer2[115] = tempchar;
	buffer2[116] = (unsigned char)tempsize;

	buffer2 += 126; // beginning of DMX data
	tempoutint = EthDesc[outind].startchannel; // starting light for ethernet
	memcpy(buffer2, &outpixels[tempoutint], tempsize); // copy lights from outpixels

	pkt.SetSourcePort(outportnum);
	pkt.SetDestinationPort(outportnum);
	tempsize += 126;
	buffer2 = (unsigned char *)&EthBuffer[0]; // the entire buffer to go out
	pkt.AddData(buffer2, tempsize);

	pkt.Send(EthDesc[outind].ip); // send to correct IP address

	outind +=1;//next universe
	universecount+=1;
	if (outind >= 511)// prevent runaways
		{
		iprintf("ETH INDEX ERROR");
		outind = 511;
		EthDesc[outind].univ = 0; // hard set to stop looping
		}
	}
}

