#ifndef XMAS11

#define XMAS11 (1)

struct showdesc
{
UINT16 type;
UINT16 timeinshow, nextshow, randtime;
UINT16 startchannel, numchannels, combineflag;
UINT16 progbegin, progend, progsel, newflag, tempflag;
double stopwatch;
};

struct desclamp
{
INT16 R1, G1, B1, R2, G2, B2, R3, G3, B3; // three colors, lowest 10 bits only
INT16 T01, T12, T23, T34; // time between colors; T0,T4 is assumed to be black
INT16 ltime1, ltime2, ltime3;
INT16 prognum;
};

// Aug3 2011, a descarch has two numbers to indicate start/stop light numbers
struct descarch
{
INT16 R1, G1, B1, R2, G2, B2, R3, G3, B3; // three colors, lowest 10 bits only;
INT16 T01, T12; // time between colors; T0,T4 is assumed to be black
INT16 ltime1, ltime2;
INT16 begin, end; // 0-5
INT16 archnum; // 0-3 to select arch
};
struct onoff
{
INT16 ltime1, ltime2, ltime3;
INT16 T01, T12, T23;
INT16 begin, end; //
};

struct pixel
{
unsigned char red;
unsigned char grn;
unsigned char blu;
};
/*
 * Describer of universes and which local channels they correspond to
 */
struct universelist
{
IPADDR ip;
INT16 startchannel;
INT16 numchannels;
INT16 univ;
unsigned char pad1;
unsigned char pad2;
};




// MAR 2013
// showsetup allows an array of programs which runshows steps through
// type is 0, 1, 2, 3, 4, EthernetUniverse
//
// 0 end of data
// 1 RGB cards
// 2 ONOFF cards
// 3 duals
// 4 Trios
// >10 Ethernet universe destination

// The loop simply runs and calls the type of show to calculate until
// it sees type 0.  This allows quick changes to what channels do what.
struct showsetup
{
int type, timeinshow, nextshow, startchan, numchan, progbegin, progend;
};

#define NUMETHLIGHTS (2500)
#define NUMLIGHTS (0) // all RGB are one light

#define NUMARCHS (3)
#define NUMTREES (8)
#define NUMSTICKS (6)
#define NUMINFLATE (4)
#define NUMONOFF (32)

#define NUMINTS (NUMLIGHTS * 2) // 32 bits per light
#define NUMINTSPACKET (16) // 16 ints per packet, 8 lights per interrupt
#define NUMINTSONOFF (NUMONOFF/16)//two onoff boards for 32 triacs
//#define NUMONOFF (NUMINTSPACKET * NUMINTSONOFF)
#define FULLBRI (0x46F1FC5F) // Green muted, blue part muted

#define SPIINTCLR (0x0001)
#define SETSPIINT (0x0100)

void saybuffsize();
void setlight(int pos, INT16 red, INT16 grn, INT16 blu);
void setonoff(int pos);
void clearlights(int start, int number);
void copylights(int from, int to);
void clearallonoff();
void clearonoff(int start, int number);
void setlightchar(int pos, unsigned char red, unsigned char grn, unsigned char blu);


#endif

